/* Copyright (c) 2004 Petr Bilek
   Tento program je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor kontrola_obsahu_lekci.c */

#include <string.h>
#include "../definice.h"
#include "../struktury.h"
#include "../lib.h"
#include "chlib.h"
int zkontroluj_lekci(short int t, type_informace * info);

int kontrola_obsahu_lekci()
{
    short int l;
    type_informace info;
    printf("\nKONTROLA OBSAHU LEKCI\n");


    for (l = 1; l <= LEKCE; l++) {
	if (nacti_info(l, &info, jmeno_info_lekce())) {
	    fprintf(stderr, "Nelze nacist informace pro LEKCI %i\n", l);
	    return 1;
	}
	if (zkontroluj_lekci(l, &info))
	    return 1;
    }
    return 0;
}

int zkontroluj_lekci(short int l, type_informace * info)
{
    FILE *soubor;
    short int odstavcu, radku, mezernik;
    char radek[RADEK];

    if ((soubor = fopen(jmeno_lekceXX(l), "rt")) == NULL) {
	fprintf(stderr, "Nelze otevrit soubor %s\n", jmeno_lekceXX(l));
	return 1;
    }
    odstavcu = radku = mezernik = 0;
    while (!nacti_radek(radek, sizeof(radek) / sizeof(char), soubor)) {
	if (!strncmp(radek, "#odstavec", 9) ||
	    !strncmp(radek, "#!odstavec", 10)) {
	    odstavcu++;
	    radku = 0;
	    if (!strncmp(radek, "#!", 2))
		mezernik = 0;
	    else
		mezernik = 1;
	    if ((mezernik && !info->mezernik)
		|| (!mezernik && info->mezernik)) {
		fprintf(stderr,
			"LEKCE %i: v INFO je oznacen mezernik %i, ale "
			"v odstavci %i je konec %s\n", l, info->mezernik,
			odstavcu, radek);
	    }
	} else if (strncmp(radek, "#konec", 6)) {
	    radku++;
	    if (!obsahuje_vse(info->pismena, radek, 1)) {
		fprintf(stderr,
			"LEKCE %i: odstavec: %i radek %i: obsahuje neznamy"
			" znak ze znaku:\n{%s}\n", l, odstavcu, radku,
			info->pismena);
	    }
	    if (obsahuje_mezery(radek)) {
		fprintf(stderr,
			"LEKCE %i: odstavec: %i radek %i: "
			"obsahuje nepripustne mezery\n",
			l, odstavcu, radku);
	    }
	} else
	    break;
    }

    if (odstavcu <= 0) {
	fprintf(stderr, "Nenalezl jsem zadny odstavec v LEKCI %i\n", l);
	return 1;
    }
    return 0;
}
