/* Copyright (c) 2004 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor lock.c PROFI */
#ifdef PSANIPROFI

#include <unistd.h>
#include <string.h>
#include "strukturyw.h"
#include "box3.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "barvy.h"

#define ROZMERY 20
#define ROZMERX 50
#define POZICEY (LINES/2 - ROZMERY/2)
#define POZICEX (COLS/2  - ROZMERX/2)

void lock_zobraz(WINDOW *, boolean, unsigned short int);

void lock()
{
    WINDOW *new_lock;
    static boolean spusteno;
    type_uziv slozka;
    unsigned short pokus = 0;
    char *chyba;
    char heslo[PW_LEN];

    if (spusteno)
        return;
    else
        spusteno = 1;

    if (nacti_slozku(&slozka, &chyba)) {
        /* == 2 pri vytvoreni noveho souboru, == 1 pri chybe */
        print_hl(2, "Nelze nast sloku s daty uivatele!\n", chyba);
        return;
    }

    if (!strcmp(slozka.heslo, "")) {
        print_hl(1, "Nen zadno heslo!");
        spusteno = 0;
        return;
    }

    if ((new_lock = newwin2(ROZMERY, ROZMERX, POZICEY, POZICEX)) == NULL) {
        print_hl(1, "CHYBA: Nepodailo se zobrazit okno lock!");
        if (global_get(g_warning) == g_w_ano)
            perror("lock()");
        return;
    }

    lock_zobraz(new_lock, 0, 0);
    pridej_do_priority_w(1, new_lock, stdscr, LINES - 1, 0);
    tiskni_dle_priority();

    memset(heslo, '\0', PW_LEN);

    while (1) {
        (void) zadej_text(heslo, PW_LEN, POZICEY + ROZMERY - 4,
                          POZICEX + 2, 0, 1);
        sifruj(heslo, slozka.heslo_I);
        if (strncmp(heslo, slozka.heslo, PW_LEN)) {
            odeber_z_priority(new_lock);
            lock_zobraz(new_lock, 1, pokus);
            pridej_do_priority_w(1, new_lock, stdscr, LINES - 1, 0);
            print_hl(1, "Chybn heslo. Zkuste to jet jednou a pomalu!");
            sleep(3);
            odeber_z_priority(new_lock);
            lock_zobraz(new_lock, 0, ++pokus);
            pridej_do_priority_w(1, new_lock, stdscr, LINES - 1, 0);
            tiskni_dle_priority();
            memset(heslo, '\0', PW_LEN);
        } else
            break;
    }

    odeber_z_priority(new_lock);
    delwin2(new_lock);
    tiskni_dle_priority();
    spusteno = 0;
}

void
lock_zobraz(WINDOW * new_lock, boolean zamek, unsigned short int pokus)
{
    unsigned short int x, y;
    wattron2(new_lock, COLOR_PAIR(COLOR_PASSWORD_HLAVNI) | A_BOLD);
    for (y = 0; y < ROZMERY; y++)
        for (x = 0; x < ROZMERX; x++)
            mvwaddch2(new_lock, y, x, ' ');
    box3(new_lock, 'I', '=');
#define X ROZMERX/2-8
#define Y 3
    if (!zamek) {
        mvwprintw2(new_lock, Y + 0, X, "      .-x-.    ");
        mvwprintw2(new_lock, Y + 1, X, "     /i   i\\  ");
        mvwprintw2(new_lock, Y + 2, X, "     I     V   ");
    } else {
        mvwprintw2(new_lock, Y + 0, X + 6, "      .-x-.    ");
        mvwprintw2(new_lock, Y + 1, X + 6, "     /i   i\\  ");
        mvwprintw2(new_lock, Y + 2, X + 6, "     V     I   ");
    }
    mvwprintw2(new_lock, Y + 3, X, "   /-LJ---LJ-\\");
    mvwprintw2(new_lock, Y + 4, X, "   |         | ");
    mvwprintw2(new_lock, Y + 5, X, "   |]  (8)  [| ");
    mvwprintw2(new_lock, Y + 6, X, "   |   (8)   | ");
    mvwprintw2(new_lock, Y + 7, X, "   ==-=====-== ");
#undef Y
#undef X

    wattron2(new_lock, COLOR_PAIR(COLOR_PASSWORD_TEXT) | A_BOLD);
    mvwprintw2(new_lock, 2, 2, "PROGRAM JE UZAMEN");

    mvwprintw2(new_lock, ROZMERY - 10, 2, "POZOR:");
    mvwprintw2(new_lock, ROZMERY - 9, 2,
               "Pokud jste zamkli  program ve chvli kdy b");
    mvwprintw2(new_lock, ROZMERY - 8, 2,
               "psan lekce nebo testu, men  as vm stle");
    mvwprintw2(new_lock, ROZMERY - 7, 2, "ubh!");

    mvwprintw2(new_lock, ROZMERY - 5, 2, "Zadejte heslo:");

    if (pokus)
        MVWPRINTW2(new_lock, ROZMERY - 2, 2,
                   "Byl proveden %2u nespn pokus" " pro odemen!",
                   pokus);


}
#endif
