/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor spusttest.c */

#include <limits.h>
#include <string.h>
#include <errno.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "zobraz_odstavec.h"

static FILE *soubor_t;
static char radek_t[RADEK];


int inicializuj_test(type_uziv * slozka, type_odstavec * odstavec)
{
    char *chybaodst2[] =
        { " NENALEZEN DN ODSTAVEC\n", "          < OK >" };

    if ((soubor_t = fopen(jmeno_testuXX(odstavec->lekce), "rt")) == NULL) {
        print_hl(2, jmeno_testuXX(odstavec->lekce),
                 ":  soubor nelze otevt");
        return 1;
    }
/**************************************************************************/

    odstavec->odstavcu = 0;
    odstavec->znaku = 0;
    odstavec->radku = 0;

    while (!nacti_radek(radek_t, sizeof(radek_t) / sizeof(char), soubor_t)) {
        if (!strncmp(radek_t, "#konec", 6)
            || !strncmp(radek_t, "#!konec", 7)) {
            (odstavec->odstavcu) = 1;
            if (!strncmp(radek_t, "#!", 2))
                odstavec->mezernik = 0;
            else
                odstavec->mezernik = 1;
            break;
        }
        (odstavec->radku)++;
        odstavec->znaku += secti_znaky(radek_t);
    }
/****************************************************************************/
    if (odstavec->odstavcu == 0) {
        (void) button(chybaodst2, 2, 1, 4, 28, LINES / 2 - 2,
                      COLS / 2 - 14);
        return 1;
    }

    if (fseek(soubor_t, 0, SEEK_SET)) {
        if (global_get(g_warning) == g_w_ano)
            perror("fseek");
        return 1;
    }

    odstavec->oradek = odstavec->radku;
    odstavec->oznaku = odstavec->znaku;
    return 0;
}

/**********************************/
/**********************************/


int spust_test(type_uziv * slozka, type_nastaveni * nastaveni,
               type_odstavec * odstavec)
{
    unsigned int znak, radku, chyb, vterin;
    int ch;
    type_informace infotest;

    char *pokus_znamka[] = { "         PSAN TESTU \n\n",
        "  <JEN ZKUSIT>  ", "<NA ZNMKU>"
    };
    char *pokus[] = { "         PSAN TESTU \n\n",
        "  <JEN ZKUSIT>"
    };
    int na_znamku;

    if (slozka->napsano_test[odstavec->lekce - 1] < POKUSU)
        na_znamku = button(pokus_znamka, 3, 1, 5, 31, 10, 21) - 1;
    else
        na_znamku = button(pokus, 2, 1, 5, 31, 10, 21) - 1;

    if (na_znamku < 0)
        return 1;               /* chyba buttonu */

    obnov_nadpis3(slozka, nastaveni, odstavec, na_znamku);
    znak = radku = chyb = vterin = 0;

#ifndef PSANIPROFI
    werase2(sub_psani);
#else
    vymaz_okno(sub_psani);
#endif
    obnov_radek1("Psan testu po sputn ji nelze zastavit!", -1,
                 znak, radku, chyb, vterin, odstavec->mezernik);

    print_hl(1, "Ne zanete, mete zmknout <BACKSPACE>!");
    obnov_psani();
    tiskni_dle_priority();

#ifndef PSANIPROFI
    ch = '\0';
#else
    ch = zobraz_odstavec(soubor_t, radek_t, RADEK, odstavec);
#endif

    while (ch != ' ') {
        if ((ch == KEY_BACKSPACE) || (ch == 'k') || (ch == 'K')) {
            tiskni_dle_priority();
            global_set(g_run, g_run_null);
            return 1;
        }
        ch = getch3();
    }

    global_set(g_run, g_run_t);

    if (slozka->napsano_test[odstavec->lekce - 1] < POKUSU && na_znamku) {
        slozka->napsano_test[odstavec->lekce - 1]++;
    }
    if (uloz_slozku(slozka))
        print_hl(2, "CHYBA: data se nepodailo uloit do souboru ",
                 jmeno_souboru());


    while (!nacti_radek(radek_t, sizeof(radek_t) / sizeof(char), soubor_t)) {
        if (!strncmp(radek_t, "#konec", 6)
            || !strncmp(radek_t, "#!konec", 7))
            break;
        else {
            radku++;
            pis_radek(&vterin, radek_t, radku, &znak, &chyb,
                      odstavec->mezernik, 1);
        }
    }

    if (fclose(soubor_t) && (global_get(g_warning) == g_w_ano))
        perror("fclose");
    global_set(g_run, g_run_null);
    odstavec->oznaku = znak;
    obnov_psani();
    tiskni_dle_priority();

    infotest = informace_o_testech(odstavec->lekce, slozka);
    vyhodnot_test(slozka, odstavec, infotest,
                  znamka_lekce(infotest, odstavec->oznaku, chyb, vterin),
                  na_znamku);
    return 0;
}
