/* Copyright (c) 2003 Petr Bilek
Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor tisk_obrazovky.c PROFI */
#ifdef PSANIPROFI

#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "priorita.h"

/*void cteni_obrazovky(chtype *);
void tisk_zapis(chtype *); // toto je v lib.h */
void tisk_okna(chtype *, type_priorita);
void tisk_zapisniku(chtype *, type_priorita);

void tisk_obrazovky(void)
{
    chtype *obrazovka;

    if ((obrazovka = (chtype *) calloc(COLS * LINES, sizeof(obrazovka[0])))
        == NULL) {
        print_hl(1, "tisk_obrazovky(): Nedostatek pamti");
        return;
    }

    cteni_obrazovky(obrazovka);
    /* vytisteni do souboru */
    tisk_zapis(obrazovka);
    free(obrazovka);
}

void tisk_okna(chtype * obrazovka, type_priorita polozka)
{
    unsigned int yb, xb, ym, xm, x, y;

    getbegyx2(polozka.win, yb, xb);
    getmaxyx2(polozka.win, ym, xm);
    if (yb < 0 || ym < 0)
        return;
#define X (xb + x)
#define Y (yb + y)
    for (y = 0; y < ym; y++)
        for (x = 0; x < xm; x++)
            obrazovka[Y * COLS + X] = mvwinch2(polozka.win, y, x);
#undef X
#undef Y
}

void tisk_zapisniku(chtype * obrazovka, type_priorita polozka)
{
    unsigned int yb, xb, ym, xm, x, y;

    getbegyx2(polozka.win, yb, xb);
    getmaxyx2(polozka.win, ym, xm);
    if (yb < 0 || ym < 0)
        return;

#define X (polozka.col_min + x)
#define Y (polozka.row_min + y)
#define X_PAD (polozka.col_min + polozka.pad_column)
#define Y_PAD (polozka.row_min + polozka.pad_row)

    for (y = 0; y < polozka.row_max - polozka.row_min; y++)
        for (x = 0; x < polozka.col_max - polozka.col_min; x++)
            obrazovka[Y * COLS + X] =
                mvwinch2(polozka.win, Y_PAD + y, X_PAD + x);
#undef X
#undef Y
#undef X_PAD
#undef Y_PAD
}

void tisk_zapis(chtype * obrazovka)
{
    unsigned int x, y;
    char jmeno_souboru[71];
    FILE *soubor;

    strcpy(jmeno_souboru, "/tmp/");
    print_hl(1, "Obrazovka sejmuta. "
             "Zadejte jmno souboru, do kterho bude uloena:\n"
             "Pozor(!) Existujc soubor bude pepsn!\n\n");

    (void) zadej_text(jmeno_souboru,
                      sizeof(jmeno_souboru) / sizeof(jmeno_souboru[0]),
                      LINES - 2, 0, 0, 0);

    if ((soubor = fopen(jmeno_souboru, "wt")) == NULL) {
        print_hl(2, jmeno_souboru, ": Soubor se nepodailo otevt.");

        if (global_get(g_warning) == g_w_ano)
            perror("tisk_zapis()");
        return;
    }

    for (y = 0; y < (LINES); y++) {
        for (x = 0; x < (COLS); x++)
            fprintf(soubor, "%c",
                    (char) (obrazovka[y * COLS + x] & A_CHARTEXT));
        fprintf(soubor, "\n");
    }

    if (fclose(soubor)) {
        print_hl(3, jmeno_souboru, ": Soubor se nepodailo zavt.");
        if (global_get(g_warning) == g_w_ano)
            perror("fclose");
    } else
        print_hl(1, "Obrazovka byla spn uloena.");
}


void cteni_obrazovky(chtype * obrazovka)
{
    unsigned int pr, p_oken;
    int x, y;

    for (y = 0; y < LINES; y++)
        for (x = 0; x < COLS; x++)
            obrazovka[y * COLS + x] = mvinch2(y, x);

    for (pr = 0; pr <= MAXPRI; pr++)
        for (p_oken = 0; p_oken < pocet_oken; p_oken++) {
            if ((poradnik[p_oken].priorita != pr))
                continue;
            if (poradnik[p_oken].typ == 0) {    /* okno window */
                tisk_okna(obrazovka, poradnik[p_oken]);
            } else if (poradnik[p_oken].typ == 1) {     /* zapisnik pads */
                tisk_zapisniku(obrazovka, poradnik[p_oken]);
            }
        }
}
#endif
